#include "saccharine.h"

void saccharide( S, C, thresh, fmult, diff, N2 )
float *S, *C, thresh, fmult, diff; int N2;
{
  int		real, imag,
		amp, phase;
  float		a, b,
  		average = .00000001,
  		movie;
  double	sum = .00000001;
  int		i;


  for ( i = 0; i <= N2; i++ ) {
    imag = phase = ( real = amp = i<<1 ) + 1;
    a = ( i == N2 ? *(S+1) : *(S+real) );
    b = ( i == 0 || i == N2 ? 0. : S[imag] );
    sum += (*(C+amp) = hypot( a, b ));
    *(C+phase) = -atan2( b, a );
  }
  
  for ( i=0; i <= N2; i++ ) {
    amp = i<<1;
    average += ((float) (i+1)) * (*(C+amp) / sum);
  }

  if (diag)
    fprintf(stderr,"mean frequency: %f amplitude sum: %f\n",
	    average * reveal, sum * (float) N2);

  if (average >= .8) {
    movie = (average *= diff);
    if (invert) {
      while ( movie <= (float) N2 ) {
	if ( *(C + ( ((int) movie)<<1 ) ) > thresh )
	  *(C + ( ((int) movie)<<1 )) *= fmult;
	movie += average;
      }
    }
    else {
      while ( movie <= (float) N2 ) {
	if ( *(C + ( ((int) movie)<<1 ) ) < thresh )
	  *(C + ( ((int) movie)<<1 )) *= fmult;
	movie += average;
      }  
    }
  }

  for ( i = 0; i <= N2; i++ ) {
    imag = phase = ( real = amp = i<<1 ) + 1;
    S[real] = *(C+amp) * cos( *(C+phase) );
    if ( i != N2 )
      S[imag] = -*(C+amp) * sin( *(C+phase) );
  }
}

