#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/delmacros.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>

#define ARRSIZE 16384
#define SIZE 512

extern SFHEADER      sfdesc[NFILES];

        float xin[ARRSIZE],out[2*ARRSIZE],del[100000];

 
double
del1(p,n_args)

float *p;

{
        long i,nsamps,n,m,count,smps = 0;
        float amp,val,temp,wait,delamp,xmax=0;
        int l[2],j,k,z;
        char *malloc();
        extern struct stat sfst[NFILES];
        extern int lineset;
        extern float array[SIZE],tabs[2]; /* for setline */
        
/*  p0=insk, p1=outsk, p2=dur, p3=amp, p4=delay, p5=delay amp */

        if (p[2] == 0)
                p[2] = ((float)(sfst[0].st_size - SIZEOF_BSD_HEADER)
                         /(float)sfclass(&sfdesc[0])/(float)sfchans(&sfdesc[0])
                         /sfsrate(&sfdesc[0])) - p[0];
        setnote(p[0],p[2],0);
        nsamps = setnote(p[1],p[2],1);

	if (sfchans(&sfdesc[1]) != 2) {
		fprintf(stderr,"output file must be stereo!!!!!!!\n");
		return(-1);
		}
	
	if ( (p[4] * SR) > 100000 ) {
		fprintf(stderr,"delay time is too long!!!!!!!\n");
		return(-1);
		}

        if(!lineset) {
                for(j = 0; j < SIZE; j++) array[j] = 1;
                fprintf(stderr,"Set phrase curve to all 1's\n");
                lineset = 1;
                }
        tableset(p[2], SIZE, tabs);

        wait = p[4];
        xmax = p[4];
        delamp = p[5];
        delset(del,l,xmax);

        z = SR/100;
        j = 0;
        amp = p[3];
        for (i = nsamps; i > 0; i -= ARRSIZE) {
                count = (i < ARRSIZE) ? i : ARRSIZE;
                bgetin(xin,0,count);
                count *= 2; /* output is 2-channel */
                for (n = 0,m = 0; n < count; n += 2) {
                        while (!j--) {
                                val = tablei(smps,array,tabs) * amp;
                                j = z;
                                smps += z;
                                }
			xin[m] *= val;
                        DELGET(del,wait,l,temp);
                        out[n] = xin[m];
                        out[n+1] = temp;
                        DELPUT(xin[m],del,l);
			m++;
                        }
                baddout(out,1,count);
                }
	
	nsamps = xmax * SR;
	for (i = 0; i < nsamps; i++) {
                DELGET(del,wait,l,temp);
                out[0] = 0;
                out[1] = temp;
		ADDOUT(out,1);
		}

       endnote(1);
}

profile()
{
	UG_INTRO("del1", del1);
}
