#include "../H/ugens.h"
#include "../H/sfheader.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>

#define ARRSIZE 16384
#define SIZE 512

extern SFHEADER      sfdesc[NFILES];
 
        float amp,val,del[100000],xmax,tail;
        float xin[ARRSIZE],out[ARRSIZE],cutoff,test=1;
double
delay(p,n_args)

float *p;

{
        long i,nsamps,nend,n,count,smps=0;
        int wait,j,z,ii,l1[2],chans;
        extern int lineset;
        extern float array[SIZE],tabs[2];
        extern struct stat sfst[NFILES];
        
/*  p0=insk, p1=outsk, p2=indur, p3=amp, p4=delay, p5=regen,
    p6=maxlengthoutbeyond       */

        if (p[2] == 0)
                p[2] = ((float)(sfst[0].st_size - SIZEOF_BSD_HEADER)
                         /(float)sfclass(&sfdesc[0])/(float)sfchans(&sfdesc[0])
                         /sfsrate(&sfdesc[0])) - p[0];
        nsamps = setnote(p[0],p[2],0);
        setnote(p[1],p[2],1);
        xmax=.99;
        delset(del,l1,xmax);

	if (sfchans(&sfdesc[1]) != 1) {
		fprintf(stderr,"output file must be mono!!!!!!!\n");
		return(-1);
		}
	
	if ( (p[4] * SR) > 100000 ) {
		fprintf(stderr,"delay time is too long!!!!!!!\n");
		return(-1);
		}

        if(!lineset) {
                for(j = 0; j < SIZE; j++) array[j] = 1;
                fprintf(stderr,"Set phrase curve to all 1's\n");
                lineset = 1;
                }
        tableset(p[2], SIZE, tabs);

        cutoff = .001;
        for (tail = 0; tail < p[6]; tail += p[4]) {
                test *= p[5];
                if (test < cutoff)
                        break;
                }
        nend = tail * SR;

        for (i = 0; i < 28000; i++) {
                del[i] = 0;
                }

        amp = p[3];
        wait = (int)(p[4] * SR + .5);
        z = SR/100;
        j = 0;
        for (i = nsamps; i > 0; i -= ARRSIZE) {
                count = (i < ARRSIZE) ? i : ARRSIZE;
                bgetin(xin,0,count);
                for (n = 0; n < count; n++) {
                        while (!j--) {
                                val = tablei(smps,array,tabs) * amp;
                                j = z;
                                smps += z;
                                }
                        out[n] = (xin[n] * val) + delget(del,p[4],l1) * p[5];
                        delput(out[n],del,l1);
                        }
                baddout(out,1,count);
                }

        for (i = nend; i > 0; i -= ARRSIZE) {
                count = (i < ARRSIZE) ? i : ARRSIZE;
                for (n = 0; n < count; n++) {
                        out[n] = delget(del,p[4],l1) * p[5];
                        delput(out[n],del,l1);
                        }
                baddout(out,1,count);
                }
       endnote(1);
}


profile()
{
	UG_INTRO("delay", delay);
}
