#include "/musr/H/ugens.h"

g17(p,n_args)

/* Computes transfer function using Chebyshev polynomials
First argument (after number) is the index value for
which the function will create the harmonics specified by the following
arguments.  */


float *p;
int n_args;
{       
	int i,j,fnum,len;
	float Tn,Tn1,Tn2,x,d,*f;

	fnum=p[0];
	len=fsize(fnum);
	f=floc(fnum);

	d=(float)(len/2-.5);
        for(i=0; i<len; i++) {
	      x=(i/d-1.)/p[1];
	      f[i]=0;
	      Tn1=1;
	      Tn=x;
	      for (j=2; j<(n_args); j++) {
		  f[i]=p[j]*Tn+f[i];
		  Tn2=Tn1;
		  Tn1=Tn;
		  Tn=2*Tn1*x-Tn2;
              }
/*      printf("%d, %f\n",i,f[i]);*/
        }

}

		 
