# makefile for Minc
# Be version - Alistair Riddell
#
# Cmix - sys

SHELL		= /bin/sh
INCLUDES 	= -I /NewDisk/be/Headers/
OBJ			= .
CC 			= mwcc
CFLAGS		= -nosyspath -O2 -DPPC603=1 -Hcpplvl=3 -I./ \
	-DHAVE_STRING_H \
	-DSTDC_HEADERS

LD 			= bld -xml -o $(GENLIB) $(OBJECTS)
LDFLAGS		= -l -nodefaults $(BELIBRARIES)/libbe.so $(BELIBRARIES)/libdll.a
GENLIB = genlib.a
CFILES =  oscil.ccp oscili.ccp osciln.ccp oscilni.cpp \
		table.ccp tablei.ccp evp.ccp reson.ccp \
	  rsnset.ccp evset.ccp tableset.ccp cpspch.ccp \
	cpsoct.ccp octpch.ccp buzz.ccp\
	  rrand.ccp boost.ccp allpole.ccp \
	delset.ccp delput.ccp delget.ccp dliget.ccp\
	  reverb.ccp rvbset.ccp comb.ccp \
	combset.ccp allpass.ccp \
	  pchoct.ccp octcps.ccp pchcps.ccp \
	boscili.ccp bbuzz.ccp ballpole.ccp brrand.ccp\
	  hpluck.ccp hcomb.ccp setline.ccp \
	random.ccp ampdb.ccp\
	  getsample.ccp breson.ccp resonz.ccp \
	pluck.ccp hplset.ccp pluckset.ccp randf.ccp \
	spray.ccp wshape.ccp bpluck.ccp\
	  pchmidi.ccp movcomb.ccp

OBJECTS = oscil.o oscili.o osciln.o oscilni.o table.o tablei.o evp.o reson.o \
	  rsnset.o evset.o tableset.o cpspch.o cpsoct.o octpch.o buzz.o\
	  rrand.o boost.o allpole.o delset.o delput.o delget.o dliget.o\
	  reverb.o rvbset.o comb.o combset.o allpass.o\
	  pchoct.o octcps.o pchcps.o boscili.o bbuzz.o ballpole.o brrand.o\
	  hpluck.o hcomb.o setline.o random.o ampdb.o\
	  getsample.o breson.o resonz.o pluck.o hplset.o pluckset.o randf.o spray.o wshape.o bpluck.o\
	  pchmidi.o movcomb.o

IFILES =  ../H/ugens.h


all : genlib.a

genlib.a:	$(OBJECTS)
#	rm -f genlib.a

$(CFILES): $(IFILES)

#install:
#	cp ${GENLIB} ${LIBDIR}
	
#clean:
#	rm -f $(OBJECTS)

#lint: $(CFILES)
#	lint $(FLAGS) -DLINT $?
