/* p0,2,4,5,6,8,10.. are times, p1,3,5,7,9,11.. are amps, total number of
 * arguments is n_args, result is stuffed into array array of length length
 */

#include <stdio.h>
#include <unistd.h>

#define SIZE 1024

extern void closesf(void);
extern int lineset=0;  			/* initialized array */

//double array[SIZE];      /* setline array for envelope */

int setline(float *,int ,float *);

int
setline(float *p,int n_args,float *array)
{
	double increm;
	int i,j,k,points;

	if((n_args % 2) != 0) {
		fprintf(stderr,"Something wrong with phrase, check args...\n");
		closesf();
	}

 lineset = 1;   /* initialized array */

	increm = (double)(p[n_args - 2] - p[0])/(double)SIZE;
	for(j=0,i=0; j < (n_args-2); j += 2) {
		points = (int)((double)(p[j+2] - p[j]) / increm +.5);
		if(p[j+2] != p[j]) {
			if(points <= 0) points = 1;
//fprintf(stderr," %f < %f or %d > SIZE\n",p[j+2],SIZE, points,SIZE);
			if((p[j+2] < p[j]) || (points > SIZE)) {
				fprintf(stderr," confusion on phrase card %f < %f or %d > %d\n",p[j+2],p[j], points,SIZE);
				closesf();
				}
			for(k=0; k < points; k++) {
				array[i++] = ((float)k/(float)points)
					* (p[j+3] - p[j+1]) + p[j+1];
				if(i == SIZE) return 0;
			}
		}
	}
	i--;
	while(++i < SIZE) array[i] = array[i-1];
	return 0;
}
