#define SOUND
#include "../H/ugens.h"
#include "../H/NeXTsfheader.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/times.h>       /* obsolete on VAX replace with new proc */
#include <sys/time.h>       /* obsolete on VAX replace with new proc */

extern int NBYTES;           /* size of buffer to allocate */
extern float SR;

int  sfd[NFILES];            /* soundfile descriptors */
int  pointer[NFILES];	     /* to be used as pointer within sound buffer */
int  bufsize[NFILES];        /* word length of buffer */
int  status[NFILES];
char peakoff[NFILES];

char *sndbuf[NFILES];        /* address of buffer */
			   
char wipe_is_off[NFILES];       /* this is for wipeout */
long  filepointer[NFILES];   /* to save current pointer in file */

SFHEADER      sfdesc[NFILES];

float SR;   /* now declared here rather than in the profile */

inrepos(samps,fno)
int samps,fno;

{
	int seeking,amt;

	amt = samps * sfchans(&sfdesc[fno]) + pointer[fno];

	if ( (amt >= 0) && (amt < bufsize[fno]) ) {
		pointer[fno] = amt;	/* reposition inside buffer */
		return(pointer[fno]);
		}
	
	seeking = (amt - bufsize[fno]) * sfclass(&sfdesc[fno]);

	if ( (filepointer[fno] = lseek(sfd[fno],seeking,1)) == -1 ) {
		fprintf(stderr,"CMIX: Bad inrepos lseek, file: %d\n",fno);
		closesf();
		}

	_readit(fno);
	pointer[fno] = 0;
	return(filepointer[fno]);
}

outrepos(samps,fno)
int samps,fno;

{
	int seeking,amt;

	if(!status[fno]) {
		fprintf(stderr,"file %d is write protected!\n",fno);
		perror("write");
		closesf();
		}

	amt = samps * sfchans(&sfdesc[fno]) + pointer[fno];

	if ( (amt >= 0) && (amt < bufsize[fno]) ) {
		pointer[fno] = amt;	/* inside current buffer	*/
		return(pointer[fno]);
		}
	
	if(wipe_is_off) _backup(fno);
	if(!peakoff[fno]) _chkpeak(fno);
	_writeit(fno); 		/* write out current buffer */
	seeking = (amt - bufsize[fno]) * sfclass(&sfdesc[fno]);

	if ( (filepointer[fno] = lseek(sfd[fno],seeking,1)) == -1 ) {
		fprintf(stderr,"CMIX: bad outrepos lseek, file: %d\n",fno);
		closesf();
		}
	
	if(wipe_is_off) _readit(fno);
	pointer[fno] = 0;
	return(filepointer[fno]);
}

