#include "ugens.h"

int FSPACE = 512;   /* initial allocation of space for farrays, in 4byte words. 
	       	   * better initial guess will result in better use
		   * of memory allocations */
int NBYTES = 32768; /* byte size of buffers to use for disk i/o, the larger the
		   * better, usually, since there will be less i/o */

void profile(void);
void
profile()
{
	UG_INTRO("place",place);
//	UG_INTRO("mix",mix);
//	UG_INTRO("stereo",stereo);
	UG_INTRO("matrix",matrix); 
	UG_INTRO("mikes",mikes); 
	UG_INTRO("mikes_off",mikes_off); 
	UG_INTRO("space",space); 
	UG_INTRO("setline",setline); 
}
