/*
Date Last Modified - Tue Oct 16 09:49:42 GMT-0400 1990
*/
#include "/musr/H/ugens.h"
#include "/musr/H/sfheader.h"
#include <stdio.h>

extern	SFHEADER	sfdesc[NFILES];  /* to access header information */

rsn(p,n_args)
float *p;
{
	/* p0=outstart, p1=dur, p2=inskip,p3=centerfreq, p4=bandwidth 
	p5=centerfreq, p6=bandwidth*/ 
	/* cf and bw are in hz */

	int i,input,output,nsamps,nchans;
	float rsnetc[9],rsnetd[9],xin[4],out[4];

	nchans = sfchans(&sfdesc[0]);  /* see sfheader.h for macros desc. */
	fprintf(stderr,"nchans %d\n",nchans);
	fprintf(stderr,"n_args %d\n",n_args);
	xinit = 0; // 0 = clear. Then after first call set to 1 for rszset
	input=0; output=1;
	nsamps=setnote(p[0],p[1],output);
	setnote(p[2],p[1],input);
	rszset(p[3],p[4],xinit,rsnetc);
	if ((nchans > 1) && (n_args == 7)) {
		rszset(p[5],p[6],xinit,rsnetd);
		fprintf(stderr,"2 Chan reson\n");
	}
	else if (n_args < 6) fprintf(stderr,"Needs 6 args\n");
	for(i=0; i<nsamps; i++) {
		GETIN(xin,input);
		out[0] = resonz(xin[0],rsnetc);
		if (nchans > 1) out[1] = resonz(xin[1],rsnetd);
		WIPEOUT(out,output);
	}
	endnote(output);
}
