#import "/musr/H/ugens.h"
#import <stdio.h>
#import "/musr/H/NeXTsfheader.h"

#define SIZE 1024

extern SFHEADER sfdesc[NFILES];

int lineset=0;
float array[SIZE];

double rsn(p,n_args)
float *p;
{
	/* p0=outstart, p1=dur, p2=inskip,p3=centerfreq, p4=bandwidth */ 
	/* cf and bw are in hz */

int i,j,count,input,output,nsamps;
float srate, rsnetc[9],xin[4],out[4],slamp,tabs[2],array[SIZE];
//	fprintf(stderr,"This rsnx...\n");
	input=0; output=1;
	setnote(p[0],p[1],output);
  nsamps=setnote(p[2],p[1],input);
	srate = sfsrate(&sfdesc[0]); // get the sr of input file

	// temp set up setline
	count = srate/200;
	if(!lineset) {
		for(j = 0; j < SIZE; j++) array[j] = 1;
		fprintf(stderr,"Set phrase curve to all 1's\n");
		lineset = 1;
	}
	j=0;
	rszset(p[3],p[4],0.,rsnetc);
	tableset(p[1], SIZE, tabs);	// set up table for amp
	for(i=0; i<nsamps; i++) {
		while(!j--) {
			slamp = tablei(i,array,tabs);
			j=count;
		}
		GETIN(xin,input);
		out[0] = resonz(xin[0],rsnetc);
		out[1] = resonz(xin[1],rsnetc);
		out[0] *= slamp;
		out[1] *= slamp;
		ADDOUT(out,output);
	}
	endnote(output);
}

double sl(p,n_args)
float *p;
{
	int i;
	setline(p,n_args,SIZE,array);
	lineset=1;
}