#define maxdl 14000
#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/macros.h"
#include "strums.h"
  strumq strumq1;
typedef struct {
        int p,del;
        float d[maxdl],c1,c2;
        } delayq;
  delayq dq;

double bend1(float *,int , double *);
extern setnote (float, float, int); 
extern sset(float ,float ,float,strumq *);
extern tableset(float,int,float *);
extern fsize(int);
extern   endnote(int);
extern delayset(float,delayq *);
extern strum(int,strumq *);
extern  dist(float);
extern delay(int,delayq *);

double bend1(float *p,int n_args, double *pp)

/* 1-string guitar with delay and distortion
   Part of a set of 4 programs--see start4.c for more info.
   bend1(star, dur, pitch0,pitch1,glissfcn
   decay time, Ny freq decayt, dist gain,loop gain, loop pitch
   premonitor, postmonitor)    */

  {
  float out[4],tabe,tags[2];
  float freqa,a,b,d,dgain,fbgain;
  float freqb,diff;
  float *glissf,freq;
  int gliss,leng,j;
  long i,nsamps;
  extern strumq strumq1;
  extern delayq dq;

  out[0]=out[1]=out[2]=out[3]=0.0;
  d = 0;

  nsamps=setnote(pp[0],pp[1],0);

  freqa=cpspch(pp[2]);
  freqb=cpspch(pp[3]);
  diff = freqb - freqa;

  dgain = pp[7];
  fbgain = pp[8]/dgain;
  sset(freqa,pp[5],pp[6],&strumq1);
  delayset(cpspch(pp[9]),&dq);

  gliss = pp[4];
  glissf = (float *)floc(gliss);
  leng = fsize (gliss);
  tableset(pp[1],leng,tags);

  j= (float)SR/freqa;

  printf("set completed\n");

  for (i=0;i<nsamps;i++) {

    if(!--j) {
          tabe = table(i,glissf,tags);
          freq = diff*tabe+freqa;
          j = (float)SR/freq;
          sset(freq,pp[5],pp[6],&strumq1);
          }

      a = strum(d,&strumq1);

      b = dist(dgain*a);
      d = fbgain*delay(b,&dq);
      out[0] = pp[10]*a + pp[11]*b;
      ADDOUT(out,0);
      }
      printf("loopcompleted\n");
  
  endnote(0);
return 0.0;
}
