#include "../H/ugens.h"

float SR = 44100; /* Default sampling rate */
int FSPACE = 1;   /* initial allocation of space for farrays, in 4byte words. 
                   * better initial guess will result in better use
                   * of memory allocations */
int NBYTES = 32768; /* byte size of buffers to use for disk i/o, the larger the
                   * better, usually, since there will be less i/o */
 
void profile();
void profile()
{
        UG_INTRO("start",start);
        UG_INTRO("bend",bend);
        UG_INTRO("scomb",scomb);
        UG_INTRO("fret",fret);
        UG_INTRO("start4",start4);
        UG_INTRO("pick4",pick4);
        UG_INTRO("fret4",fret4);
        UG_INTRO("start6",start6);
        UG_INTRO("pick6",pick6);
        UG_INTRO("fret6",fret6);
        UG_INTRO("bend4",bend4);
        UG_INTRO("start1",start1);
        UG_INTRO("fret1",fret1);
        UG_INTRO("bend1",bend1);
        UG_INTRO("vstart1",vstart1);
        UG_INTRO("vfret1",vfret1);
        UG_INTRO("vbend1",vbend1);
}
