#include "../H/ugens.h"
#include <stdio.h>
#include <unistd.h>

extern void closesf(void);
extern gen2(struct gen *gen);
extern gen3(struct gen *gen);
extern gen5(struct gen *gen);
extern gen6(struct gen *gen);
extern gen7(struct gen *gen);
extern gen9(struct gen *gen);
extern gen10(struct gen *gen);
extern gen17(struct gen *gen);
extern gen18(struct gen *gen);
extern gen24(struct gen *gen);

int   ngens;       /*total of gens so far, initialized in main at 1*/
float *farrays[256];
int sizeof_farray[256];
struct gen gen;

double makegen(float *p,int n_args, double *pp);

double
makegen(float *p,int n_args, double *pp)
{
	int genno;

/* p0=storage loc, p1=gen no, p2=size, p3--> = args */
	p=p;
	genno = (int)pp[0];
	if (genno < 0) genno = -genno;
	gen.size = (int)pp[2];
	if((genno > ngens) || (pp[2] != sizeof_farray[genno])) {
		if((farrays[genno] = (float *) malloc((unsigned) gen.size * FLOAT))  == NULL) {
				fprintf(stderr,
				"makegen: Can't get any function space.\n");
				closesf();
		}

	if(genno > ngens) ngens++;
		sizeof_farray[genno] = (int)pp[2];
	}
	gen.nargs  = n_args-3;
	gen.pvals = pp+3;
	gen.array = farrays[genno];
	gen.slot = (int)pp[0];

	switch ((int)pp[1]) {
		case 24: gen24(&gen); break;
		case 18: gen18(&gen); break;
		case 17: gen17(&gen); break;
		case 10: gen10(&gen); break;
		case  7: gen7(&gen); break;
		case  5: gen5(&gen); break;
		case  9: gen9(&gen); break;
		case  6: gen6(&gen); break;
		case  3: gen3(&gen); break;
		case  2: gen2(&gen); break;
		default: fprintf(stderr,"makegen: There is no gen%d\n",(int)pp[1]);
	}
 return 0;
}
