#include "../H/ugens.h"
#include "../H/sfheader.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>

extern 	fsize(int);
extern 	double *floc(int);

double m_sampfunc(float *,int, double *);
double m_sampfunci(float *,int, double *);

double
m_sampfunc(float *p,int n_args, double *pp)
{
	int size, fnumber,skipin;
	double *thefunct;

/* p0 == number of the function, p1 == amount to skip */

	p=p;n_args=n_args;
	fnumber = pp[0];
	size = fsize(fnumber);
	skipin = (pp[1] < size) ? pp[1] : size - 1; /* to avoid segvs */
	thefunct = floc(fnumber);
	return(thefunct[skipin]);
}

double
m_sampfunci(float *p,int n_args, double *pp)	/* interpolated version of sampfunc -- DAS 5/90 */
{
	int fnumber,size,skipin, skipin2;
	double *thefunct, frac;

/* p0 == number of the function, p1 == amount to skip */

	p=p;n_args=n_args;
	fnumber = pp[0];
	skipin = pp[1];
	frac = pp[1] - skipin;
	thefunct = (double *) floc(fnumber);
	size = fsize(fnumber);
	if(skipin >= size-2) {
		skipin = size - 1;
		skipin2 = skipin;
	}
	else
		skipin2 = skipin + 1;
	return(thefunct[skipin] + frac * (thefunct[skipin2]-thefunct[skipin]));
}
