/* newfft.f -- translated by f2c (version of 16 February 1991  0:35:15).
   You must link the resulting object file with the libraries:
	-lf2c -lm -lc   (in that order)
*/

#include "f2c.h"

int fft_(real *s, long *n, real *output);
int ftrans_(real *s, complex *f, long *n);
int shuff_(real *s, complex *f, long *n);
int combin_(complex *f, int *j, long *n);

/* Subroutine */ 
int fft_(real *s, int *n, real *output)
{
    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    double c_abs(complex *);

    /* Local variables */
    static complex f[8192];
    static integer j;
    extern /* Subroutine */ int ftrans_(real *, complex *, integer *);
    static integer nd2;

    /* Parameter adjustments */
    --output;
    --s;

    /* Function Body */
    ftrans_(&s[1], f, n);
    nd2 = *n / 2;
    i__1 = nd2;
    for (j = 1; j <= i__1; ++j) {
/* L10: */
	output[j] = c_abs(&f[j - 1]);
    }
    return 0;
} /* fft_ */

/* Subroutine */

int ftrans_(real *s, complex *f, int *n)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static integer j;
    extern /* Subroutine */ int shuff_(real *, complex *, integer *), combin_(
	    complex *, integer *, integer *);
    static integer length;

    /* Parameter adjustments */
    --f;
    --s;

    /* Function Body */
    shuff_(&s[1], &f[1], n);
    length = 2;
L1:
    i__1 = *n;
    i__2 = length;
    for (j = 1; i__2 < 0 ? j >= i__1 : j <= i__1; j += i__2) {
/* L2: */
	combin_(&f[1], &j, &length);
    }
    length += length;
    if (length - *n <= 0) {
	goto L1;
    } else {
	goto L3;
    }
L3:
    return 0;
} /* ftrans_ */

/* Subroutine */
int shuff_(real *s, complex *f, int *n)
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    complex q__1;

    /* Local variables */
    static integer i, j, ifort, jfort, m1, m2;

    /* Parameter adjustments */
    --f;
    --s;

    /* Function Body */
    i__1 = *n;
    for (ifort = 1; ifort <= i__1; ++ifort) {
	i = ifort - 1;
	j = 0;
	m2 = 1;
L1:
	m1 = m2;
	m2 += m2;
	if (i % m2 - m1 >= 0) {
	    goto L2;
	} else {
	    goto L3;
	}
L2:
	j += *n / m2;
L3:
	if (m2 - *n >= 0) {
	    goto L4;
	} else {
	    goto L1;
	}
L4:
	jfort = j + 1;
/* L5: */
	i__2 = ifort;
	i__3 = jfort;
	q__1.r = s[i__3], q__1.i = 0.f;
	f[i__2].r = q__1.r, f[i__2].i = q__1.i;
    }
    return 0;
} /* shuff_ */

/* Subroutine */
int combin_(complex *f, int *j, int *n)
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    doublereal d__1;
    complex q__1, q__2;

    /* Builtin functions */
    void c_exp(complex *, complex *), pow_ci(complex *, complex *, integer *);


    /* Local variables */
    static complex emjt;
    static integer l;
    static complex z;
    static integer n2, loc1, loc2;

    /* Parameter adjustments */
    --f;

    /* Function Body */
    d__1 = 6.283185f / (real) (*n);
    q__2.r = d__1 * 0.f, q__2.i = d__1 * -1.f;
    c_exp(&q__1, &q__2);
    emjt.r = q__1.r, emjt.i = q__1.i;
    n2 = *n / 2;
    i__1 = n2;
    for (l = 1; l <= i__1; ++l) {
	loc1 = l + *j - 1;
	loc2 = loc1 + n2;
	i__2 = l - 1;
	pow_ci(&q__2, &emjt, &i__2);
	i__3 = loc2;
	q__1.r = q__2.r * f[i__3].r - q__2.i * f[i__3].i, q__1.i = q__2.r * f[
		i__3].i + q__2.i * f[i__3].r;
	z.r = q__1.r, z.i = q__1.i;
	i__2 = loc2;
	i__3 = loc1;
	q__1.r = f[i__3].r - z.r, q__1.i = f[i__3].i - z.i;
	f[i__2].r = q__1.r, f[i__2].i = q__1.i;
/* L1: */
	i__2 = loc1;
	i__3 = loc1;
	q__1.r = f[i__3].r + z.r, q__1.i = f[i__3].i + z.i;
	f[i__2].r = q__1.r, f[i__2].i = q__1.i;
    }
    return 0;
} /* combin_ */

