#include <stdio.h>
#include "pv.h"

void burrowing( S1, S2, C1, C2, N2, mult, thres )
float *S1, *S2, *C1, *C2, mult, thres;
int N2;
{
  int 		real, imag,
		amp,
		phase;
  float 	a1,a2,
		b1,b2;
  int 		i;


  for ( i = 0 ; i <= N2 ; i++ ) {
    imag = phase = ( real = amp = i<<1 ) + 1 ;
    a1 = ( i == N2 ? *(S1+1) : *(S1+real) ) ;
    b1 = ( i == 0 || i == N2 ? 0. : *(S1+imag) ) ;
    a2 = ( i == N2 ? S2[1] : S2[real] ) ;
    b2 = ( i == 0 || i == N2 ? 0. : *(S2+imag) ) ;
    *(C1+amp) = hypot( a1, b1 );
    *(C1+phase) = -atan2( b1, a1 );
    *(C2+amp) = hypot( a2, b2 );
    *(C2+phase) = -atan2( b2, a2 );
  }
  
  for ( i=0; i <= N2; i++ ) {
    amp = i<<1;
    if ( *(C2+amp) > thres )
      *(C1+amp) *= mult;
  }

  for ( i = 0 ; i <= N2 ; i++ ) {
    imag = phase = ( real = amp = i<<1 ) + 1 ;
    *(S1+real) = *(C1+amp) * cos( *(C1+phase) );
    if ( i != N2 ) 
      *(S1+imag) = -*(C1+amp) * sin( *(C1+phase) );
  }
}
