#include "cpv.h"

extern	findroots( complex *, complex *pole, int M ) ;
extern complex cdiv(complex, complex);
extern space( int,int ) ;
extern complex conjg(complex );

void findpoles(float *, complex *, int);

void findpoles(float *coef, complex *pole, int M)
{
 int i ;
 complex *a ;

    a = (complex *) space( (M+1), sizeof(complex) ) ;
    for ( i = 0 ; i <= M ; i++ ) {
	a[i].re = coef[i] ;
	a[i].im = 0. ;
    }
    findroots( a, pole, M ) ;
    for ( i = 0 ; i < M ; i++ )
	pole[i] = cdiv( one, conjg( pole[i] ) ) ;
    free( a ) ;
}
