#include "../H/sfheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

extern 	printsf(SFHEADER *);
extern		getheadersize(SFHEADER *);

static SFCODE	ampcode = {
	SF_MAXAMP,
	sizeof(SFMAXAMP) + sizeof(SFCODE)
};

void
main(int argc,char *argv[])
	{
	int result=0,headersize,mins;
	FILE * sf;
	struct stat sfst;
	float dur=0,remsecs;
	SFHEADER sfh;
	char *sfname;

usage:	if(argc < 2) {
		printf("usage: sfprint soundfile\n");
		exit(1);
		}

 while(--argc) {
			sfname = *++argv;
//			readopensf(sfname,sf,sfh,sfst,"sfprint",result)
		if (result= (sf = fopen(sfname, "r"))  == NULL){
		fprintf(stderr, "Error opening file\n");}		
		fread(&sfh,sizeof(sfh),1,sf);
		if (stat(sfname,&sfst)){
		fprintf(stderr,"%s: cannot get status on %s\n","sfprint",sfname);
		result = -1;
		}
			if(result != 0) continue;
			printf(":::::::::::::::::::\n"); 
			printf("%s \n:::::::::::::::::::\n" ,sfname);
			printsf(&sfh);
			headersize = getheadersize(&sfh);

//			printf("header size - %d\n",headersize);
			dur = (float)(sfst.st_size - headersize)
					/ (float)sfclass(&sfh)/(float)sfchans(&sfh)
				 /sfsrate(&sfh);
			mins = dur/60;
			remsecs = dur-(mins*60);
			if(mins == 1)printf("Duration of file is %f secs. %d min %f secs\n",dur,mins,remsecs);
			else printf("Duration of file is %f secs. %d mins %f secs\n",dur,mins,remsecs);
			close(sf);
}
}
