#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/delmacros.h"
#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>

#define ARRSIZE 16384
#define SIZE 512
#define NDELS 4

extern SFHEADER      sfdesc[NFILES];

        float xin[ARRSIZE],out[2*ARRSIZE],del[100000],spread[NDELS];

double 
del4(p,n_args)

float *p;

{
        long i,nsamps,n,m,count,smps = 0;
        float amp,val,temp,wait[4],delamps[NDELS],xmax=0;
        int l[2],j,k,z;
        char *malloc();
        extern struct stat sfst[NFILES];
        extern int lineset;
        extern float array[SIZE],tabs[2]; /* for setline */
        
/*  p0=insk, p1=outsk, p2=dur, p3=amp, p4-7=del1-del4, p8-11=amp1-amp4  */

        if (p[2] == 0)
                p[2] = ((float)(sfst[0].st_size - SIZEOF_BSD_HEADER)
                         /(float)sfclass(&sfdesc[0])/(float)sfchans(&sfdesc[0])
                         /sfsrate(&sfdesc[0])) - p[0];
        setnote(p[0],p[2],0);
        nsamps = setnote(p[1],p[2],1);

	if (sfchans(&sfdesc[1]) != 2) {
		fprintf(stderr,"output file must be stereo!!!!!!!\n");
		return(-1);
		}
	
        if(!lineset) {
                for(j = 0; j < SIZE; j++) array[j] = 1;
                fprintf(stderr,"Set phrase curve to all 1's\n");
                lineset = 1;
                }
        tableset(p[2], SIZE, tabs);

        for (j = 0; j < NDELS; j++) {
                wait[j] = p[j+4];
		if ( (wait[j] * SR) > 100000 ) {
			fprintf(stderr,"delay time is too long!!!!!!!\n");
			return(-1);
			}
                xmax = (wait[j] > xmax) ? wait[j] : xmax;
                delamps[j] = p[j+8];
                spread[j] = (float)j/(float)(NDELS-1);
                }
        delset(del,l,xmax);

        z = SR/100;
        j = 0;
        amp = p[3];
        for (i = nsamps; i > 0; i -= ARRSIZE) {
                count = (i < ARRSIZE) ? i : ARRSIZE;
                bgetin(xin,0,count);
                count *= 2; /* output is 2-channel */
                for (n = 0,m = 0; n < count; n += 2) {
                        while (!j--) {
                                val = tablei(smps,array,tabs) * amp;
                                j = z;
                                smps += z;
                                }
			xin[m] *= val;
                        out[n] = out[n+1] = 0;
                        for (k = 0; k < NDELS; k++) {
                                DELGET(del,wait[k],l,temp);
                                out[n] += temp*spread[k];
                                out[n+1] += temp*(1.0-spread[k]);
                                }
                        DELPUT(xin[m],del,l);
			m++;
                        }
                baddout(out,1,count);
                }
	
	nsamps = xmax * SR;
	for (i = 0; i < nsamps; i++) {
                out[0] = out[1] = 0;
                for (k = 0; k < NDELS; k++) {
                        DELGET(del,wait[k],l,temp);
                        out[0] += temp*spread[k];
                        out[1] += temp*(1.0-spread[k]);
                        }
                DELPUT(0.0,del,l);
		ADDOUT(out,1);
		}

       endnote(1);
}

profile()
{
	UG_INTRO("del4", del4);
}
