#include "../H/ugens.h"
#include "../H/sfheader.h"
#include <stdio.h>
#include <unistd.h>

#define SIZE 1024
int lineset;
float array[SIZE];

extern void closesf(void);

float setline(float *,int, double *);

float
setline(float *p,int n_args, double *pp)
{
	double increm;
	int i,j,k,points;

	p=p;
	if((n_args % 2) != 0) {
		fprintf(stderr,"Something wrong with phrase, check args for mix setline\n");
		closesf();
	}

	lineset = 1;   /* initialized array */
	increm = (pp[n_args - 2] - pp[0])/(float)SIZE;
	for(j=0,i=0; j < (n_args-2); j += 2) {
		points = (int)((pp[j+2] - pp[j]) / increm +.5);
		if(pp[j+2] != pp[j]) {
			if(points <= 0) points = 1;
			if((pp[j+2] < pp[j]) || (points > SIZE)) {
				fprintf(stderr," confusion on phrase card\n");
				closesf();
				}
			for(k=0; k < points; k++) {
				array[i++] = ((float)k/(float)points)
					* (pp[j+3] - pp[j+1]) + pp[j+1];
				if(i == SIZE) return(0.0);
			}
		}
	}
	i--;
	while(++i < SIZE) array[i] = array[i-1]; 
	return(0.0);
}
