/*
	rsn.m
	
Date last Modified - Tue Oct 30 08:50:36 GMT-0400 1990

*/

#import "rsn.h"

@implementation RsnObj: Object
+ create {

	id newInstance;
	newInstance = [ self new ];
	return newInstance;
}

- openFile: (float *)p {
	i = (int)p[0];
	filename = (char *)i; // add filename ext
	infile = NXMapFile(filename,NX_READONLY);
	fprintf(stderr, "rsn data file - %s\n", (int)filename);
	return self;
}

- rsnm: (float)inskip Dur:(float)dur Rise:(float)rise Decay:(float)decay rsnArray:(float *)rsnetn {

	if ((inskip+dur)/SR > dura) {
		fprintf(stderr, "ERROR - sound file length exceeded.\n");
		exit(0);
	}
	fprintf(stderr,"**dur %f inskip %f outskip %f input %d\n", dur, inskip, outskip,input);
	outskip = outskip + dur; 	// outskip incremented
	nsamps=setnote(outskip,dur,output);
	fprintf(stderr,"outskip %f \n", outskip);
	getsetnote(inskip,dur,input);
	skip += inskip*SR;
	fprintf(stderr,"skip %d inskip %f nsamps %d\n", skip, inskip,nsamps);
	control = SR/200;
	for(i=0; i<nsamps; i++) {
		if(!GETSAMPLE((double)i+skip,xin,input))  break;
			if(!r--){
				enval = evp(i,f1,f1,evals);
				r = control;
	fprintf(stderr,"xin[0] %f xin[1] %f \n", xin[0], xin[1]);
			}
/*			for (out[0]=out[1]=j=k=0; j<nresons; j++, k+=9){ // alt on chans
				if (j%2) out[0] += resonz(xin[0], (rsnetn+k)) * enval;
				else out[1] += resonz(xin[1], (rsnetn+k)) * enval;
			}
*/
			temp[0]=temp[1]=0;
			for (out[0]=out[1]=j=k=0; j<nresons; j++, k+=9){
				temp[0] += resonz(xin[0],(rsnetn+k)); // try stacking them up
				temp[1] += resonz(xin[1],(rsnetn+k));
			}
//	fprintf(stderr,"temp[0] %f temp[1] %f \n", temp[0], temp[1]);
			out[0] = temp[0];
			out[1] = temp[1];
			ADDOUT(out,output);
		}

	endnote(output);
			
	return self;
}
@end

