#define maxdl 14000
#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/macros.h"
#include "strums.h"
  strumq strumq1;
  strumq strumq2;
  strumq strumq3;
  strumq strumq4;
typedef struct {
        int p,del;
        float d[maxdl],c1,c2;
        } delayq;
  delayq dq;

double fret4(float *p,int n_args, double *pp);
extern setnote (float, float, int); 
extern sset(float ,float ,float,strumq *);
extern endnote(int);
extern void delayset(float,delayq *);
extern float strum(float,strumq *);
extern float dist(float);
extern float delay(float,delayq *);

double fret4(float *p,int n_args, double *pp)

/* 4-string guitar with delay and distortion
   part of a set of 4 programs, see start4.c for more info.
   fret4(star, dur, pitch, pitch, pitch, pitch, decay time, Ny freq decayt,
   dist gain, loop gain, loop pitch, premonitor, postmonitor,    */

  {
  float out[4];
  float freq1,freq2,freq3,freq4,a,b,d,dgain,fbgain;
  long i,nsamps;
  extern strumq strumq1;
  extern strumq strumq2;
  extern strumq strumq3;
  extern strumq strumq4;
  extern delayq dq;

  out[0]=out[1]=out[2]=out[3]=0.0;
  d = 0;

  nsamps=setnote(pp[0],pp[1],0);

  freq1=cpspch(pp[2]);
  freq2=cpspch(pp[3]);
  freq3=cpspch(pp[4]);
  freq4=cpspch(pp[5]);
   
  dgain = pp[8];
  fbgain = pp[9]/dgain;
  sset(freq1,pp[6],pp[7],&strumq1);
  sset(freq2,pp[6],pp[7],&strumq2);
  sset(freq3,pp[6],pp[7],&strumq3);
  sset(freq4,pp[6],pp[7],&strumq4);
  delayset(cpspch(pp[10]),&dq);
  printf("set completed\n");


  for (i=0;i<nsamps;i++) {
      a = strum(d,&strumq1);
      a += strum(d,&strumq2);
      a += strum(d,&strumq3);
      a += strum(d,&strumq4);

      b = dist(dgain*a);
      d = fbgain*delay(b,&dq);
      out[0] = pp[11]*a + pp[12]*b;
      ADDOUT(out,0);
      }
      printf("loopcompleted\n");
  
  endnote(0);
  return 0.0;
}
