#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/macros.h"
#include "strums.h"
  strumq strumq1;

double scomb(float *p,int n_args, double *pp);
extern setnote (float, float, int); 
extern sset(float ,float ,float,strumq *);
extern tableset(float,int,float *);
extern fsize(int);
extern   endnote(int);
extern strum(int,strumq *);

double scomb(float *p,int n_args, double *pp)

 /* program to use strum routine and structure as swept comb filter */
 /* scomb(start, dur, inskip, pitch0, pitch1, sweepfcn, tf0, tNy */
 /* Uses file 1 as input, 0 as output
    tf0 is reverb time at fundamental freq, tNy is reverb time at high
    harmonics (Nyquist frequency)*/

  {
  float freq,freq0,freq1,out[4];
  float diff,*glissf,tags[4],xin[4];
  int gliss,leng,j;
  long i,nsamps;
  extern strumq strumq1;

  out[0]=out[1]=out[2]=out[3]=0.0;

  setnote(pp[2],pp[1],1);
  nsamps=setnote(pp[0],pp[1],0);

  freq0=cpspch(pp[3]);
  freq1=cpspch(pp[4]);
  diff = freq1 - freq0;

  sset(freq0,pp[6],pp[7],&strumq1);

  gliss = pp[5];

  glissf = (float *)floc(gliss);  /*function pp[4] is gliss shape */
  leng = fsize(gliss);

  j = SR/freq0; /*interrupt  once per cycle*/

  tableset(pp[1],leng,tags);

        for(i = 0; i<nsamps; i++) {
                if(!j--) {  
                        freq = diff*table(i,glissf,tags) + freq0;
                        sset(freq,pp[5],pp[6],&strumq1);
                        j = (float)SR/freq;
                }  
        GETIN(xin,1);
        out[0]=strum(xin[0],&strumq1);
        ADDOUT(out,0);
        }
  
  endnote(0);
  return 0.0;
}
