#define maxdl 14000
#include "../H/ugens.h"
#include "../H/sfheader.h"
#include "../macros/macros.h"
#include "strums.h"
  strumq strumq1;
typedef struct {
        int p,del;
        float d[maxdl],c1,c2;
        } delayq;
  delayq dq;

double start1(float *p,int n_args, double *pp);
extern setnote (float, float, int); 
extern sset(float ,float ,float,strumq *);
extern endnote(int);
extern randfill(float ,int,strumq *);
extern delayset(float,delayq *);
extern void delayclean(delayq *);
extern float strum(float,strumq *);
extern float delay(float,delayq *);
extern  float dist(float);

double start1(float *p,int n_args, double *pp)

/* 1-string guitar with delay and distortion
 analogous to start4.c, which has an explaination of how to use it and how 
 it works.
 start1(star, dur, pitch, decay time, Ny freq decayt, dist gain,
 loop gain, loop pitch, premonitor, postmonitor, plamp,squish)   */

  {
  float out[4];
  float freq1,a,b,d,dgain,fbgain;
  long i,nsamps;
  int squish;
  extern strumq strumq1;
  extern delayq dq;

  out[0]=out[1]=out[2]=out[3]=0.0;
  d = 0;

  nsamps=setnote(pp[0],pp[1],0);

  freq1=cpspch(pp[2]);
  squish = pp[11];
   
  dgain = pp[5];
  fbgain = pp[6]/dgain;
  sset(freq1,pp[3],pp[4],&strumq1);
  randfill(pp[10],squish,&strumq1);
  delayset(cpspch(pp[7]),&dq);
  delayclean(&dq);
  printf("set completed\n");


  for (i=0;i<nsamps;i++) {
      a = strum(d,&strumq1);

      b = dist(dgain*a);
      d = fbgain*delay(b,&dq);
      out[0] = pp[8]*a + pp[9]*b;
      ADDOUT(out,0);
      }
      printf("loopcompleted\n");
  
  endnote(0);
  return 0.0;
}
